unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ExtDlgs, ImageStuff, JPEG;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    lSourceFile: TLabel;
    lDestinationFile: TLabel;
    OpenDlg: TOpenPictureDialog;
    SaveDlg: TSavePictureDialog;
    lblWorking: TLabel;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure dorotations;

var
  Form1: TForm1;
  r,g,b:integer; //need for imagestuff include

implementation

{$R *.dfm}

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  jpg:tjpegimage;
  bmp:tbitmap;
  s:string;
begin
  jpg := tjpegimage.Create;
  bmp := tbitmap.create;
  try
    opendlg.Title := 'Choose Bitmap or JPEG to load...';
    opendlg.Filter :='All supported|*.bmp;*.jpg;*.jpeg|Bitmap files (*.bmp)|*.bmp|Jpeg files (*.jpg, *.jpeg)|*.jpg;*.jpeg';
    if opendlg.Execute then
    begin
      form1.lblWorking.visible := true;
      application.processmessages;
      try
        s := lowercase(extractfileext(opendlg.FileName));
        if (s = '.jpg') or (s = '.jpeg') then
        begin
          jpg.LoadFromFile(opendlg.filename);
          bmp.assign(jpg);
        end
        else if s = '.bmp' then
          bmp.LoadFromFile(opendlg.filename)
        else
        begin
          messagedlg('File extension must be bmp, jpg, or jpeg. Case insensitive.',mtError,[mbOK],0);
          exit;
        end;
        image1.Picture.Assign(bmp);
        lsourcefile.Caption := extractfilename(opendlg.FileName); //set caption
        lblWorking.caption := 'Joining...';
        application.processmessages;
        dorotations;  //rotate and stuff to make final image
      except
        messagedlg('There was an error openning the file.',mtError,[mbOK],0);
      end;
    end;
  finally
    jpg.free;
    bmp.free;
    form1.lblWorking.visible := false;
    form1.lblWorking.caption := 'Opening...';
  end;
end;

procedure dorotations;
var
  bmp,bmp1,bmp2,bmp3,bmp4:tbitmap;
begin
  if (form1.image1.picture.bitmap.Width = 0) or (form1.image1.picture.bitmap.height = 0) then exit;
  bmp := tbitmap.create;
  bmp1 := tbitmap.create;
  bmp2 := tbitmap.create;
  bmp3 := tbitmap.create;
  bmp4 := tbitmap.create;
  try
    bmp1.assign(form1.image1.picture.bitmap);
    bmp2.assign(bmp1);
    bmp3.assign(bmp1);
    bmp4.assign(bmp1);
    FlipHoroBMP(bmp2); //do flipping
    application.processmessages;
    FlipVerticalBMP(bmp3);
    application.processmessages;
    FlipHoroBMP(bmp4);
    application.processmessages;
    FlipVerticalBMP(bmp4);
    application.processmessages;
    Combine4x4TilesBMP(bmp,bmp1,bmp2,bmp3,bmp4);  //combine later bmp's into bmp
    if (bmp.width = 0) or (bmp.Height = 0) then exit;
    application.processmessages;
    form1.image1.picture.Assign(bmp);
    form1.image1.refresh;
    application.processmessages;
  finally
    bmp.free;
    bmp1.free;
    bmp2.free;
    bmp3.free;
    bmp4.free;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  bmp:tbitmap;
  s:string;
//  jpg:tJPEGImage;
begin
  savedlg.Title := 'Choose path to save bmp';     // or jpeg...';
  savedlg.Filter :='Bitmap files (*.bmp)|*.bmp';  //|Jpeg files (*.jpg, *.jpeg)|*.jpg;*.jpeg';
  if savedlg.Execute then
  begin
    s := lowercase(extractfileext(savedlg.FileName));
    case savedlg.FilterIndex of
      1:if s <> '.bmp' then savedlg.filename := savedlg.filename + '.bmp';
//      2:if (s <> '.jpg') and (s <> '.jpeg')then savedlg.FileName := savedlg.filename + '.jpg';
    end;  //end case
    s := lowercase(extractfileext(savedlg.FileName));
    if fileexists(savedlg.filename) then
      if messagedlg('File already exists. Overwrite?',mtConfirmation,mbOKCancel,0) <> mrOK then
        exit;
    lDestinationFile.Caption := savedlg.FileName;
    if (image1.Picture.bitmap.width <> 0) and (image1.Picture.bitmap.height <> 0) then
    begin
      if s = '.bmp' then image1.Picture.SaveToFile(savedlg.filename);
    end;
{   if (s = '.jpg') or (s = '.jpeg') then
    begin
      jpg.Assign(bmp);
      jpg.CompressionQuality := 100;
    end;}
  end;
end;

end.

