//ImageStuff


unit ImageStuff;

interface

uses extctrls, sysutils,graphics;

type TBlurMap = array[0..2] of array[0..2] of single;

procedure limitrgb(var r,g,b:integer);
procedure clearrgb(var r,g,b:integer);
procedure GetRGB(Color:integer;k:single;var r,g,b:integer);

procedure DifferenceBitmaps(var image1:TImage;image2:TBitmap);
procedure BitmapFastBlur(ToBlur:TBitmap;var destination:TImage;blurmap:TBlurMap);
procedure DarkenImage(threshold:integer;r,g,b:integer;var Image:TImage);

//derivatives
procedure FindHoroDerivative(var image1:timage;k:single;UseABS:boolean);
procedure FindVertDerivative(var image1:timage;k:single;UseABS:boolean);
procedure FindDiagDerivative(var image1:timage;k:single;UseABS:boolean);
procedure FindHoroDerivativeBMP(var bmp:tbitmap;k:single;UseABS:boolean);
procedure FindVertDerivativeBMP(var bmp:tbitmap;k:single;UseABS:boolean);
procedure FindDiagDerivativeBMP(var bmp:tbitmap;k:single;UseABS:boolean);

//invert
procedure InvertBMP(var bmp:tbitmap);
procedure InvertImage(var image1:timage);

//blend
procedure AvgTwoBMP(var bmp:tbitmap;bmp2:tbitmap);
procedure AvgThreeBMP(var bmp:tbitmap;bmp2:tbitmap;bmp3:tbitmap);
procedure AvgFourBMP(var bmp:tbitmap;bmp2:tbitmap;bmp3:tbitmap;bmp4:tbitmap);

//keep brightest
procedure KeepBrightestBMP(var bmp:tbitmap;bmp2:tbitmap);
procedure KeepBrightest(var image1:timage;image2:timage);

//brighten
procedure BrightenBMP(var bmp:tbitmap;roffset,goffset,boffset:integer);
procedure BrightenImage(var image1:timage;roffset,goffset,boffset:integer);

//rotate, mirror, and the like
procedure FlipVerticalBMP(var bmp:tbitmap);
procedure FlipVerticalImage(var image1:timage);

procedure FlipHoroBMP(var bmp:tbitmap);
procedure FlipHoroImage(var image1:timage);

procedure Combine4x4TilesBMP(var bmp:tbitmap;bmp1,bmp2,bmp3,bmp4:tbitmap);

procedure ReplaceColorBMP(var bmp:tbitmap; fromcolor,tocolor:integer); //replace fromcolor with tocolor in bmp
procedure ReplaceColorImage(var image1:timage; fromcolor,tocolor:integer); //replace fromcolor with tocolor in image1

implementation

uses unit1;

procedure DifferenceBitmaps(var image1:TImage;image2:TBitmap);
var
  x,y:integer;
  P1,P2:PByteArray;
  step,n:integer;
  r,g,b:integer;
begin
  step := 1;
  for y := 0 to (image1.picture.bitmap.Height div step) - 1 do
  begin
    P1 := image1.picture.bitmap.ScanLine[y * step];
    P2:= image2.ScanLine[y * step];
    for x := 0 to (image1.picture.bitmap.width div step) - 1 do
    begin
//        rgb(255 - abs(p1[x* 3 + 2] - p2[x* 3 + 2]),255- abs(p1[x*3 + 1] - p2[x*3 + 1]),255 - abs(p1[x*3] - p2[x*3]));
      n := x * step;
      r := 0;
      g := 0;
      b := 0;
      r := p1[n*3+2] - p2[n*3+2];
      g := p1[n*3+1] - p2[n*3+1];
      b := p1[n*3] - p2[n*3];
      limitrgb(r,g,b);
      p1[n*3+2] := r;
      p1[n*3+1] := g;
      p1[n*3] := b;
    end;
  end;
  image1.picture.bitmap.Canvas.Draw(0,0,image1.picture.bitmap);
end;

procedure BitmapFastBlur(ToBlur:TBitmap;var destination:TImage;blurmap:TBlurMap);
var
  x,y:integer;
  P1,P2,P3,PD:PByteArray;
  r,g,b:double;
  c:double;
  h,w:integer;
const sqrt2 = 1.4142135623730950488016887242097;
begin
  h := toblur.Height - 1;
  w := toblur.width - 1;
  for y := 0 to h do
  begin
    if y > 0 then P1 := toblur.ScanLine[y - 1];
    P2 := toblur.ScanLine[y];
    if y < h then P3 := toblur.ScanLine[y + 1];
    PD := destination.picture.Bitmap.ScanLine[y];
    for x := 0 to w do
    begin
      r := 0.0;
      g := 0.0;
      b := 0.0;
      c := 0.0;

{      r := r + p2[x*3+2];
      g := g + p2[x*3+1];
      b := b + p2[x*3];
      c := c + 1;}


      if x > 0 then
      begin
        //getrgb(tempimage.Canvas.Pixels[x-1,y],1,r,g,b);
        r := r + p2[(x-1)*3+2] * blurmap[0,1];
        g := g + p2[(x-1)*3+1] * blurmap[0,1];
        b := b + p2[(x-1)*3] * blurmap[0,1];
        c := c + blurmap[0,1];
      end;

      //getrgb(tempimage.Canvas.Pixels[x+1,y],1,r,g,b);
      if x < w then
      begin
        r := r + p2[(x+1)*3+2] * blurmap[2,1];
        g := g + p2[(x+1)*3+1] * blurmap[2,1];
        b := b + p2[(x+1)*3] * blurmap[2,1];
        c := c + blurmap[2,1];
      end;

      if y > 0 then
      begin
        //getrgb(tempimage.Canvas.Pixels[x,y-1],1,r,g,b);
        r := r + p1[x*3+2] * blurmap[1,0];
        g := g + p1[x*3+1] * blurmap[1,0];
        b := b + p1[x*3] * blurmap[1,0];
        c := c + blurmap[1,0];
      end;

      //getrgb(tempimage.Canvas.Pixels[x,y+1],1,r,g,b);
      if y < h then
      begin
        r := r + p3[x*3+2] * blurmap[1,2];
        g := g + p3[x*3+1] * blurmap[1,2];
        b := b + p3[x*3] * blurmap[1,2];
        c := c + blurmap[1,2];
      end;

      if (y > 0) and (x > 0) then
      begin
        //getrgb(tempimage.Canvas.Pixels[x-1,y-1],1/1.4,r,g,b);
        r := r + p1[(x-1)*3+2] * blurmap[0,0];
        g := g + p1[(x-1)*3+1] * blurmap[0,0];
        b := b + p1[(x-1)*3] * blurmap[0,0];
        c := c + blurmap[0,0];
      end;

      if (x > 0) and (y < h) then
      begin
        //getrgb(tempimage.Canvas.Pixels[x-1,y+1],1/1.4,r,g,b);
        r := r + p3[(x-1)*3+2] * blurmap[0,2];
        g := g + p3[(x-1)*3+1] * blurmap[0,2];
        b := b + p3[(x-1)*3] * blurmap[0,2];
        c := c + blurmap[0,2];
      end;

      if (y > 0) and (x < w) then
      begin
        //getrgb(tempimage.Canvas.Pixels[x+1,y-1],1/1.4,r,g,b);
        r := r + p1[(x+1)*3+2] * blurmap[2,0];
        g := g + p1[(x+1)*3+1] * blurmap[2,0];
        b := b + p1[(x+1)*3] * blurmap[2,0];
        c := c + blurmap[2,0];
      end;

      if (x < w) and (y < h) then
      begin
        //getrgb(tempimage.Canvas.Pixels[x+1,y+1],1/1.4,r,g,b);
        r := r + p3[(x+1)*3+2] * blurmap[2,2];
        g := g + p3[(x+1)*3+1] * blurmap[2,2];
        b := b + p3[(x+1)*3] * blurmap[2,2];
        c := c + blurmap[2,2];
      end;

      r := r/c;
      g := g/c;
      b := b/c;
      
      if r > 255 then r := 255.0;
      if g > 255 then g := 255.0;
      if b > 255 then b := 255.0;

      if r < 0 then r := 0.0;
      if g < 0 then g := 0.0;
      if b < 0 then b := 0.0;

      pd[x*3+2] := trunc(r);
      pd[x*3+1] := trunc(g);
      pd[x*3] := trunc(b);
    end;
  end;
  destination.picture.Bitmap.Canvas.Draw(0,0,destination.Picture.Bitmap);
end;

procedure DarkenImage(threshold:integer;r,g,b:integer;var Image:TImage);
var
  x,y:integer;
  P1:PByteArray;
begin
  for y := 0 to image.picture.Height - 1 do
  begin
    P1 := image.picture.bitmap.ScanLine[y];
    for x := 0 to image.picture.width - 1 do
    begin
      if (p1[x*3+2] < threshold) or (p1[x*3+1] < threshold) or (p1[x*3] < threshold) then
      begin
        p1[x*3+2] := r;
        p1[x*3+1] := g;
        p1[x*3] := b;
      end;
    end;
  end;
  image.picture.Bitmap.Canvas.Draw(0,0,image.Picture.Bitmap);
end;


procedure GetRGB(Color:integer;k:single;var r,g,b:integer);
var
n:integer;
c:integer;
begin
    if color = 0 then
    begin
      r := 0;
      g := 0;
      b := 0;
      exit;
    end;
    if color > -1 then
    begin
      r := r + trunc(($000000FF and color) * k);
      n := ($0000FF00 AND color);
      if n > 0 then
        for c := 1 to 8 do
          n := n shr 1;
      g := g + trunc(n * k);

      n := $00FF0000 AND color;
      if n > 0 then
        for c := 1 to 16 do
          n := n shr 1;
      b := b + trunc(n * k);
    end;
end;

procedure clearrgb(var r,g,b:integer);
begin
  r := 0;
  g := 0;
  b := 0;
end;

procedure limitrgb(var r,g,b:integer);
begin
  if r > 255 then r := 255;
  if g > 255 then g := 255;
  if b > 255 then b := 255;
  if r < 0 then r := 0;
  if g < 0 then g := 0;
  if b < 0 then b := 0;
end;

procedure FindHoroDerivative(var image1:timage;k:single;useABS:boolean);
//if useABS is true, then don't use 127 offset.
var
  x,y:integer;
  r,g,b:integer;
  P1:PByteArray;
  bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.Picture.Bitmap);
    for y := 0 to bmp.Height - 1 do
    begin
      P1 := bmp.ScanLine[y];
      for x := 0 to bmp.width - 2 do
      begin
        r := p1[(x+1)*3+2] - p1[x*3+2];
        g := p1[(x+1)*3+1] - p1[x*3+1];
        b   := p1[(x+1)*3]   - p1[x*3];
        if useABS then
        begin
          r := abs(r);
          g := abs(g);
          b := abs(b);
        end else begin
          r := trunc(r*k) + 127;
          g := trunc(g*k) + 127;
          b := trunc(b*k) + 127;
        end;
        limitrgb(r,g,b);
        p1[x*3+2] := r;
        p1[x*3+1] := g;
        p1[x*3]   := b;
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
    image1.Picture.Bitmap.Assign(bmp);
  finally
    bmp.free;
  end;
end;

procedure FindVertDerivative(var image1:timage;k:single;UseABS:boolean);
//if useABS is true, then don't use 127 offset.
var
  x,y:integer;
  r,g,b:integer;
  P1,P2:PByteArray;
  bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.Picture.Bitmap);
    for y := 0 to bmp.Height - 2 do
    begin
      P1 := bmp.ScanLine[y];
      P2 := bmp.ScanLine[y+1];
      for x := 0 to bmp.width - 1 do
      begin
        r := p1[x*3+2] - p2[x*3+2];
        g := p1[x*3+1] - p2[x*3+1];
        b := p1[x*3]   - p2[x*3];
        if useABS then
        begin
          r := abs(r);
          g := abs(g);
          b := abs(b);
        end else begin
          r := trunc(r*k) + 127;
          g := trunc(g*k) + 127;
          b := trunc(b*k) + 127;
        end;
        limitrgb(r,g,b);
        p1[x*3+2] := r;
        p1[x*3+1] := g;
        p1[x*3]   := b;
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
    image1.Picture.Bitmap.Assign(bmp);
  finally
    bmp.free;
  end;
end;

procedure FindDiagDerivative(var image1:timage;k:single;UseABS:boolean);
//if useABS is true, then don't use 127 offset.
var
  x,y:integer;
  r,g,b:integer;
  P1,P2:PByteArray;
  bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.Picture.Bitmap);
    for y := 0 to bmp.Height - 2 do
    begin
      P1 := bmp.ScanLine[y];
      P2 := bmp.ScanLine[y+1];
      for x := 0 to bmp.width - 2 do
      begin
        r := p1[x*3+2] - p2[(x+1)*3+2];
        g := p1[x*3+1] - p2[(x+1)*3+1];
        b := p1[x*3]   - p2[(x+1)*3];
        if useABS then
        begin
          r := abs(r);
          g := abs(g);
          b := abs(b);
        end else begin
          r := trunc(r*k) + 127;
          g := trunc(g*k) + 127;
          b := trunc(b*k) + 127;
        end;
        limitrgb(r,g,b);
        p1[x*3+2] := r;
        p1[x*3+1] := g;
        p1[x*3]   := b;
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
    image1.Picture.Bitmap.Assign(bmp);
  finally
    bmp.free;
  end;
end;

procedure FindHoroDerivativeBMP(var bmp:tbitmap;k:single;useABS:boolean);
//if useABS is true, then don't use 127 offset.
var
  x,y:integer;
  r,g,b:integer;
  P1:PByteArray;
begin
    for y := 0 to bmp.Height - 1 do
    begin
      P1 := bmp.ScanLine[y];
      for x := 0 to bmp.width - 2 do
      begin
        r := p1[(x+1)*3+2] - p1[x*3+2];
        g := p1[(x+1)*3+1] - p1[x*3+1];
        b   := p1[(x+1)*3]   - p1[x*3];
        if useABS then
        begin
          r := abs(r);
          g := abs(g);
          b := abs(b);
        end else begin
          r := trunc(r*k) + 127;
          g := trunc(g*k) + 127;
          b := trunc(b*k) + 127;
        end;
        limitrgb(r,g,b);
        p1[x*3+2] := r;
        p1[x*3+1] := g;
        p1[x*3]   := b;
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
end;

procedure FindVertDerivativeBMP(var bmp:tbitmap;k:single;UseABS:boolean);
//if useABS is true, then don't use 127 offset.
var
  x,y:integer;
  r,g,b:integer;
  P1,P2:PByteArray;
begin
    for y := 0 to bmp.Height - 2 do
    begin
      P1 := bmp.ScanLine[y];
      P2 := bmp.ScanLine[y+1];
      for x := 0 to bmp.width - 1 do
      begin
        r := p1[x*3+2] - p2[x*3+2];
        g := p1[x*3+1] - p2[x*3+1];
        b := p1[x*3]   - p2[x*3];
        if useABS then
        begin
          r := abs(r);
          g := abs(g);
          b := abs(b);
        end else begin
          r := trunc(r*k) + 127;
          g := trunc(g*k) + 127;
          b := trunc(b*k) + 127;
        end;
        limitrgb(r,g,b);
        p1[x*3+2] := r;
        p1[x*3+1] := g;
        p1[x*3]   := b;
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
end;

procedure FindDiagDerivativeBMP(var bmp:tbitmap;k:single;UseABS:boolean);
//if useABS is true, then don't use 127 offset.
var
  x,y:integer;
  r,g,b:integer;
  P1,P2:PByteArray;
begin
  for y := 0 to bmp.Height - 2 do
  begin
    P1 := bmp.ScanLine[y];
    P2 := bmp.ScanLine[y+1];
    for x := 0 to bmp.width - 2 do
    begin
      r := p1[x*3+2] - p2[(x+1)*3+2];
      g := p1[x*3+1] - p2[(x+1)*3+1];
      b := p1[x*3]   - p2[(x+1)*3];
      if useABS then
      begin
        r := abs(r);
        g := abs(g);
        b := abs(b);
      end else begin
        r := trunc(r*k) + 127;
        g := trunc(g*k) + 127;
        b := trunc(b*k) + 127;
      end;
      limitrgb(r,g,b);
      p1[x*3+2] := r;
      p1[x*3+1] := g;
      p1[x*3]   := b;
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;


procedure InvertBMP(var bmp:tbitmap);
var
  x,y:integer;
  P1:PByteArray;
begin
  for y := 0 to bmp.Height - 1 do
  begin
    P1 := bmp.ScanLine[y];
    for x := 0 to bmp.width - 1 do
    begin
      p1[x*3+2] := 255 - p1[x*3+2];
      p1[x*3+1] := 255 - p1[x*3+1];
      p1[x*3]   := 255 - p1[x*3];
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;

procedure InvertImage(var image1:timage);
var
  bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.Picture.Bitmap);
    InvertBMP(bmp);
    image1.picture.Bitmap.assign(bmp);
  finally
    bmp.Free;
  end;
end;

procedure AvgTwoBMP(var bmp:tbitmap;bmp2:tbitmap);
var
  x,y:integer;
  P1,P2:PByteArray;
begin
  for y := 0 to bmp.Height - 1 do
  begin
    P1 := bmp.ScanLine[y];
    P2 := bmp2.ScanLine[y];
    for x := 0 to bmp.width - 1 do
    begin
      p1[x*3+2] := (p1[x*3+2] + p2[x*3+2]) div 2;
      p1[x*3+1] := (p1[x*3+1] + p2[x*3+1]) div 2;
      p1[x*3]   := (p1[x*3]   + p2[x*3])   div 2;
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;

procedure AvgThreeBMP(var bmp:tbitmap;bmp2:tbitmap;bmp3:tbitmap);
var
  x,y:integer;
  P1,P2,P3:PByteArray;
begin
  for y := 0 to bmp.Height - 1 do
  begin
    P1 := bmp.ScanLine[y];
    P2 := bmp2.ScanLine[y];
    P3 := bmp3.ScanLine[y];    
    for x := 0 to bmp.width - 1 do
    begin
      p1[x*3+2] := (p1[x*3+2] + p2[x*3+2] + p3[x*3+2]) div 3;
      p1[x*3+1] := (p1[x*3+1] + p2[x*3+1] + p3[x*3+1]) div 3;
      p1[x*3]   := (p1[x*3]   + p2[x*3]   + p3[x*3])   div 3;
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;

procedure AvgFourBMP(var bmp:tbitmap;bmp2:tbitmap;bmp3:tbitmap;bmp4:tbitmap);
var
  x,y:integer;
  P1,P2,P3,P4:PByteArray;
begin
  for y := 0 to bmp.Height - 1 do
  begin
    P1 := bmp.ScanLine[y];
    P2 := bmp2.ScanLine[y];
    P3 := bmp3.ScanLine[y];
    P4 := bmp4.ScanLine[y];
    for x := 0 to bmp.width - 1 do
    begin
      p1[x*3+2] := (p1[x*3+2] + p2[x*3+2] + p3[x*3+2] + p4[x*3+2]) div 3;
      p1[x*3+1] := (p1[x*3+1] + p2[x*3+1] + p3[x*3+1] + p4[x*3+1]) div 3;
      p1[x*3]   := (p1[x*3]   + p2[x*3]   + p3[x*3]   + p4[x*3])   div 3;
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;

procedure KeepBrightestBMP(var bmp:tbitmap;bmp2:tbitmap);
//find brightest for each pixel then store in bmp.
var
  x,y:integer;
  P1,P2:PByteArray;
begin
  for y := 0 to bmp.Height - 1 do
  begin
    P1 := bmp.ScanLine[y];
    P2 := bmp2.ScanLine[y];
    for x := 0 to bmp.width - 1 do
    begin
      if p2[x*3+2] > p1[x*3+2] then p1[x*3+2] := p2[x*3+2];
      if p2[x*3+1] > p1[x*3+1] then p1[x*3+1] := p2[x*3+1];
      if p2[x*3]   > p1[x*3]   then p1[x*3]   := p2[x*3];
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;

procedure KeepBrightest(var image1:timage;image2:timage);
//find brightest for each pixel then store in image1
var
  bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.picture.bitmap);
    KeepBrightestBMP(bmp,image2.picture.bitmap);
    image1.picture.assign(bmp);
  finally
    bmp.free;
  end;
end;

procedure BrightenBMP(var bmp:tbitmap;roffset,goffset,boffset:integer);
//find brightest for each pixel then store in bmp.
var
  x,y:integer;
  P1:PByteArray;
begin
  for y := 0 to bmp.Height - 1 do
  begin
    P1 := bmp.ScanLine[y];
    for x := 0 to bmp.width - 1 do
    begin
      r := p1[x*3+2] + roffset;
      g := p1[x*3+1] + goffset;
      b := p1[x*3]   + boffset;
      limitrgb(r,g,b);
      p1[x*3+2] := r;
      p1[x*3+1] := g;
      p1[x*3]   := b;
    end;
  end;
  bmp.Canvas.Draw(0,0,bmp);
end;

procedure BrightenImage(var image1:timage;roffset,goffset,boffset:integer);
//find brightest for each pixel then store in bmp.
var
  bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.Picture.Bitmap);
    BrightenBMP(bmp,roffset,goffset,boffset);
    image1.picture.bitmap.assign(bmp);
    image1.Refresh;
  finally
    bmp.free;
  end;
end;

procedure FlipHoroBMP(var bmp:tbitmap);
var
  x,y,k:integer;
  P1,P2:PByteArray;
  bmp2:tbitmap;
begin
  bmp2 := tbitmap.create;
  try
    bmp2.assign(bmp);
    k := bmp.width - 1;
    for y := 0 to bmp.Height - 1 do
    begin
      P1 := bmp.ScanLine[y];
      P2 := bmp2.ScanLine[y];
      for x := 0 to bmp.width - 1 do
      begin
        p1[x*3+2] := p2[(k-x)*3+2]; //red
        p1[x*3+1] := p2[(k-x)*3+1]; //green
        p1[x*3]   := p2[(k-x)*3];   //blue
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
  finally
    bmp2.free;
  end;
end;

procedure FlipHoroImage(var image1:timage);
var bmp:tbitmap;
begin
 bmp := tbitmap.create;
 try
   bmp.assign(image1.picture.bitmap);
   FlipHoroBMP(bmp);
   image1.Picture.Bitmap.Assign(bmp);
   image1.Refresh;
 finally
   bmp.free;
 end;
end;

procedure FlipVerticalBMP(var bmp:tbitmap);
var
  x,y,k:integer;
  P1,P2:PByteArray;
  bmp2:tbitmap;
begin
  bmp2 := tbitmap.create;
  try
    bmp2.assign(bmp);
    k := bmp.height - 1;
    for y := 0 to bmp.Height - 1 do
    begin
      P1 := bmp.ScanLine[y];
      P2 := bmp2.ScanLine[k-y];
      for x := 0 to bmp.width - 1 do
      begin
        p1[x*3+2] := p2[x*3+2]; //red
        p1[x*3+1] := p2[x*3+1]; //green
        p1[x*3]   := p2[x*3];   //blue
      end;
    end;
    bmp.Canvas.Draw(0,0,bmp);
  finally
    bmp2.free;
  end;
end;

procedure FlipVerticalImage(var image1:timage);
var bmp:tbitmap;
begin
  bmp := tbitmap.create;
  try
    bmp.assign(image1.picture.bitmap);
    FlipVerticalBMP(bmp);
    image1.picture.Bitmap.assign(bmp);
    image1.Refresh;
  finally
  end;
end;

procedure Combine4x4TilesBMP(var bmp:tbitmap;bmp1,bmp2,bmp3,bmp4:tbitmap);
var
  w,h:integer;
  x,y:integer;
  i,k1,k2:integer;
  P1,P2:PByteArray;
begin
  try
    //all tiles must be the same size.
    bmp.Width := 0;
    bmp.height := 0;
    w := bmp1.width;
    h := bmp1.height;
    if bmp2.width  <> w then exit;
    if bmp2.height <> h then exit;
    if bmp3.width  <> w then exit;
    if bmp3.height <> h then exit;
    if bmp4.width  <> w then exit;
    if bmp4.height <> h then exit;
    bmp.width  := w*2;
    bmp.height := h*2;
    bmp.Canvas.Draw(0,0,bmp1);
    bmp.Canvas.Draw(w,0,bmp2);
    bmp.Canvas.Draw(0,h,bmp3);
    bmp.Canvas.Draw(w,h,bmp4);
  except
    bmp.width := 0;
    bmp.height := 0;
  end;
end;

procedure Combine4x4TilesImage(var image:timage;image1,image2,image3,image4:timage);
var bmp:tbitmap;
begin
  bmp := tbitmap.Create;
  try
    bmp.assign(image.Picture.Bitmap);
    Combine4x4TilesBMP(bmp,image1.picture.Bitmap,image2.Picture.Bitmap,image3.picture.Bitmap,image4.picture.Bitmap);
    image1.Picture.Bitmap.Assign(bmp);
    image1.Refresh;
  finally
    bmp.free;
  end;
end;

procedure ReplaceColorBMP(var bmp:tbitmap; fromcolor,tocolor:integer); //replace fromcolor with tocolor in bmp
begin
end;

procedure ReplaceColorImage(var image1:timage; fromcolor,tocolor:integer); //replace fromcolor with tocolor in image1
begin
end;

end.
